﻿        // Chapter6.cs

        // Difference between function and a method
        // returned to the obj call
        // functions return to themselves "objects"
        // methods return to something else "objects"

        // Programming Purpose 3 parts
        // If you ever get stuck in code, ask yourself these 3 parts
        // 1. did I define something I am calling? -> someone else define it
        // 2. did I give it value? 
        // 3. did I return it? -> send it along if you dont pass its

        // Methods and Functions Defined OOP
        // nameOfFunctionOrMethod(tuple) { encapsulation/scope; }
        // myMethod() -> Empty Method all data is constructed inside the scope of the method { encapsulation/scope }
        // myCalc() { int x = 7; int y = 3; int z = x + y; return z; }

        // myMethod(param1, param2, ...) -> Parameterized Function/Method "we are passing args<data> to params to be used in the scope of the operations
        // int var_x = 7; int var_y = 3;
        // myCalc(var_x, var_y) -> myCalc(7,3)
        // myCalc(int x, int y) { int z = x + y; return z; }

        // Syntax for Methods OOP
        // <access modifier> <behavior mod> <return type> methodName() {}
        // <public,private,protected> <static,..> <void, any, bool,...>

        // Define an empty method
        // all values we need will be inside the scope of the method
        int myAddMethod() // <return type> methodName(empty)
        {
            int x = 7;
            int y = 3;
            int z = x + y; // z = 10
            return z; // return 10
        } // myAddMethod() -> 10 as int

        // 2 outputs for the call
        // calling the object
        Console.WriteLine(myAddMethod()); // print the object

// assign the object return <int 10> to a variable "best practice"
int myAddMethod_value = myAddMethod();
        Console.WriteLine(myAddMethod_value); // print the value from the variable

/*
 * Step 1 Ask the user for their first name and last name
 * Step 2 Define a function that takes 2 params from the user input with first name as param1 and lastname as param2
 * Step 3 Assign to a string fullName variable with first name then last name -> Bob Smith
 * Step 4 return fullname as string to the method
 * Step 5 output the fullname to the terminal
 */

// Step 1 Ask the user for their first name and last name
Console.WriteLine("Enter your first name: ");
string firstName = Console.ReadLine();
        Console.WriteLine("Enter your last name: ");
string lastName = Console.ReadLine();

        // Step 2 Define a function that takes 2 params from the user input with first name as param1 and lastname as param2
        string myFullName(string param_firstName, string param_lastName)
        {
            /* doc comments optional */
            // Step 3 Assign to a string fullName variable with first name then last name -> Bob Smith
            string fullName = param_firstName + " " + param_lastName;
            // Step 4 return fullname as string to the method
            return fullName;
        } // myFullName()

        string fullName = myFullName(firstName, lastName);
        Console.WriteLine(fullName);

// Event Handlers -> web forms desktop apps Publisher Subscriber page 188

// Instead of "calling" a defined function/method in a program, we "respond" to an event that occurs -> action
// call a single function/method -> single return

// Event itself "functional" onSubmit()
// Event occurs -> actions listening to this event to happen
//// Publisher/Subscriber Event/Action -> structurally
// a single event happens -> multiple actions/returns
// Publish 1 event -> 50 Subcribers / 50 different actions

