﻿// Chapter9
// Helpful charts for DateTime and TimeSpan class pages 277,279,281, 297

// Current DateTime using Now
// Now use the local system clock
// string[] varName = new List<string> 

DateTime currentDateTimeStamp; // creating the obj in memory
currentDateTimeStamp = DateTime.Now;  // !need new keyword

Console.WriteLine(currentDateTimeStamp); // 12/5/2024 10:34:27 AM

// .Add() method M/D/Y HmS
DateTime dueDate;
int days = 30; // if you ask the user thru an input<string> you need to parse or tryparse the string to int for .Add() method

dueDate = currentDateTimeStamp.AddDays(days); 
Console.WriteLine(dueDate); // 1/4/2025 10:41:55 AM

// TimeSpan
DateTime futureDateForAgingTest = currentDateTimeStamp.AddDays(88);
Console.WriteLine(futureDateForAgingTest);

// Today is now 3/3/2025 10:44:41 AM
// We want to use the future date - due date to see how far the invoice is past due
// Class<TimeSpan> = Class<DateTime> - Class<DateTime>; friends
TimeSpan pastDue = futureDateForAgingTest - dueDate;
Console.WriteLine(pastDue); // 58.00:00:00

// When would we see the "new" keyword using DateTime Class
// We use the "new" keyword when constructing a class using a different type
// integer month,day,year -> construct DateTime class from integers
int month = 3;
int day = 21;
int year = 1990;

DateTime birthday = new DateTime(year, month, day);
Console.WriteLine(birthday); // 3/21/1990 12:00:00 AM

// 2 options for formatting DateTime to string
// option 1 using string interpolation and format
Console.WriteLine(String.Format("{0:D}", birthday));
// option 2 using pipe method
Console.WriteLine(birthday.ToLongDateString()); // D format
// Wednesday, March 21, 1990
// Wednesday, March 21, 1990









