﻿// Chapter5.cs

// pages 142-150
// Operators in OOP
//// assigment operator =
//// arthmetic  + - * / ...
///// + addition number or join string
//// relational > >= < <= == != ...   relate var to value
//// logical and & or | not !   test 2 variables for True/False


// if statement
//// keywords if, else if, else
//// if tests a condition for true using relational and logical ops
//// else if RETESTS a condition using relational and logical operators when the step above returned False. else if can be restested as many times as you need.
//// else is only used once in the statement to handle the final !True
//// if is required, else if and else are optional
//// True, Retest True, False


/*
 * = equal to symbol
 * 
 * = assigning a value to an object
 * age = 18  assigning the value 18 to the var name age
 * 
 * == "in equality to" tests a condition between an object based only on value
 * age == 22 False   age == 18 True
 * 
 * === "strictly in equality to" tests a conditin between an object with the assigned type and the value. ALL 3 the obj type, value type and the value relationship needs to be True
 * 
 */

/*
 * drive, vote, drink, retire
 * age < 16 nothing
 * age >= 16 and age < 18 drive
 * age >= 18 and age < 21 drive vote
 * age >= 21 and age < 72 drive vote drink
 * age >= 72 and age < 120 drive vote drink retire
 * else age out of range to test
 */

// Define the control variable for the test
// all inputs in OOP DEFAULT to string data type
using System;

Console.WriteLine("Enter your age: ");
string age = Console.ReadLine(); // read the line that the user enters

// Test the string input to be a number between "0" and "120"
// "Bob" ! converted to int
// "21" -> 21 int

int ageInt; // assigned Null value of int

if ( int.TryParse( age, out ageInt ))
{
    Console.WriteLine($"You entered {ageInt}");
    // Valid age as int
    // Move the if statement for driving, voting, drinking and retire here from below as a nested if
    // if statement

    if (ageInt >= 0 & ageInt < 16)
    {
        // encapulate a block of code {  }
        // encapsulation
        // if ( condition ) returns True
        Console.WriteLine("You can not drive, vote, drink or retire.");
    } // if has a natural break keyword
      // if the if condition is not True then continues to the else or break
    else if (ageInt >= 16 & ageInt < 18)
    {
        Console.WriteLine("You can drive but not vote, drink or retire.");
    } // else if
    else if (ageInt >= 18 & ageInt < 21)
    {
        Console.WriteLine("You can drive and vote but not drink or retire.");
    } // else if
    else if (ageInt >= 21 & ageInt < 72)
    {
        Console.WriteLine("You can drive, vote and drink but not retire.");
    } // else if
    else if (ageInt >= 72 & ageInt < 120)
    {
        Console.WriteLine("You can drive, vote drink and retire.");
    } // else if
    else
    {
        // False after all conditions are tested and NON are True
        // finally if no valid age is tested true
        Console.WriteLine("Invalid age");
    } // nested else

} // if
else
{
    Console.WriteLine($"You entered {age}. The value you entered can not be converted to an integer");
}

// Don't Repeat Yourself
// https://en.wikipedia.org/wiki/Don%27t_repeat_yourself

// use the switch statement page 145 to test a control
//// only return cases that are True for switch
//// keywords > switch, case, default
//// switch naturally continues BUT you can use a break if 1 operation
//// break and continue on page 158

// Get an input from the user
// Set our control variable
Console.WriteLine("Enter customer code (C,R,W): ");
double discountPerc;
discountPerc = 0.0;

// input variable
string customerCode = Console.ReadLine(); // string = string

// control variable
string customerType = customerCode.ToUpper(); // convert to upper case

// switch (condition)
switch (customerType)
{
    // operators based on True
    // Customer 2.5
    // Retailers 20 -> 20.0  int->floats
    // Wholesalers 40.5
    // default cash sale 0.0
    case "C":
        Console.WriteLine("Customer Discount: ");
        double customerDiscount = 2.5;
        Console.WriteLine($"{customerDiscount}%");
        break; // page 158
    case "R":
        Console.WriteLine("Retailer Discount: ");
        double retailerDiscount = 20;
        Console.WriteLine($"{retailerDiscount}%");
        break;
    case "W":
        Console.WriteLine("Wholesaler Discount: ");
        double wholesalerDiscount = 40.5;
        Console.WriteLine($"{wholesalerDiscount}%");
        break;
    default:
        Console.WriteLine("Cash Sale: ");
        double cashDiscount = discountPerc;
        Console.WriteLine($"{cashDiscount}%");
        break;
} // switch


// looping back to original var
// option 1 for loop -> for (control,condition,op)
// option 2 do loop -> do (condition, operation) / while (control)

for (int i = 0; i < 10; i++)
{
    Console.WriteLine($"{i}"); // break happens in the conditional test

    // we want to break as a user on a value rather than the system
    double sqrt = Math.Sqrt( i ); // test if i is a perfect square
    if (i > 1 & Math.Floor(sqrt) == sqrt)
    {
        Console.WriteLine("You hit a perfect square!");
        break; // break happens based on user condition
    } // if

} // for





// EOF Chapter5.cs